//	ArrestExe - File Audit Utility
//	Copyright (C) 2002-2006 AnonyMouse
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// Project Includes:
#include "Stdafx.h"
#include "ArrestExe.h"
#include "AppUtils.h"

// General includes:

// Utility includes:
#include "FileUtils.h"
#include "StringUtils.h"

// Debug Codes:
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

NOTIFYICONDATA* CAppUtils::GetTaskTrayData()
{
	return &( ( ( CArrestExeApp* )AfxGetApp() )->m_NotifyIconData );
}

bool CAppUtils::IsRunning()
{
	return ( ( CArrestExeApp* )AfxGetApp() )->m_IsRunning;
}

void CAppUtils::SetRunning( bool ipRunning )
{
	( ( CArrestExeApp* )AfxGetApp() )->m_IsRunning = ipRunning;
	SetTaskTrayIcon( ipRunning ? TASKTRAY_RUN : TASKTRAY_STOP );
}

CAppUtils::ETaskTrayIcon CAppUtils::GetTaskTrayIcon()
{
	return ( ( CArrestExeApp* )AfxGetApp() )->m_TaskTrayIcon;
}

void CAppUtils::SetTaskTrayIcon( CAppUtils::ETaskTrayIcon ipTaskTrayIcon )
{
	// Check Icon Equal
	if( ( ( CArrestExeApp* )AfxGetApp() )->m_TaskTrayIcon == ipTaskTrayIcon )
	{
		return;
	}

	NOTIFYICONDATA* lNotifyIconData = CAppUtils::GetTaskTrayData();

	if( ipTaskTrayIcon == TASKTRAY_NONE )
	{
		// Delete Icon From TaskTray
		Shell_NotifyIcon( NIM_DELETE, lNotifyIconData );
	}
	else
	{
		// Change Icon
		switch( ipTaskTrayIcon )
		{
		case TASKTRAY_STOP:
			lNotifyIconData->hIcon = ( ( CArrestExeApp* )AfxGetApp() )->m_IconStop;
			break;
		case TASKTRAY_RUN:
			lNotifyIconData->hIcon = ( ( CArrestExeApp* )AfxGetApp() )->m_IconRun;
			break;
		case TASKTRAY_WARN:
			lNotifyIconData->hIcon = ( ( CArrestExeApp* )AfxGetApp() )->m_IconWarn;
			break;
		default:
			break;
		}
		Shell_NotifyIcon( ( ( ( CArrestExeApp* )AfxGetApp() )->m_TaskTrayIcon == TASKTRAY_NONE ) ? NIM_ADD : NIM_MODIFY, lNotifyIconData );
	}

	( ( CArrestExeApp* )AfxGetApp() )->m_TaskTrayIcon = ipTaskTrayIcon;
}

void CAppUtils::SetMainWndVisible( bool ipVisible, bool ipOnlyInitFlag )
{
	( ( CArrestExeApp* )AfxGetApp() )->m_MainWndVisible = ipVisible;
	if( !ipOnlyInitFlag )
	{
		AfxGetMainWnd()->ShowWindow( ipVisible );
	}
}

bool CAppUtils::GetMainWndVisible()
{
	return ( ( CArrestExeApp* )AfxGetApp() )->m_MainWndVisible;
}

CString CAppUtils::GetStartupLinkPath()
{
	CString lReturn = CFileUtils::GetSpecialFolderPath( CSIDL_STARTUP ) + APPUTILS_LINK_FILENAME;
	return lReturn;
}

void CAppUtils::SetDeleteServiceThread( CDeleteServiceThread* ipDeleteServiceThread )
{
	( ( CArrestExeApp* )AfxGetApp() )->m_DeleteServiceThread = ipDeleteServiceThread;
}

CDeleteServiceThread* CAppUtils::GetDeleteServiceThread()
{
	return ( ( CArrestExeApp* )AfxGetApp() )->m_DeleteServiceThread;
}
