//	ArrestExe - File Audit Utility
//	Copyright (C) 2002-2006 AnonyMouse
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once

#ifndef __APPUTILS_H__
#define __APPUTILS_H__

#include "DeleteServiceThread.h"

#define WM_TASKTRAYMSG	( WM_USER + 1192 )

#define APPUTILS_LINK_FILENAME _T( "\\ArrestExe.lnk" )

class CAppUtils
{
public:
	enum ETaskTrayIcon
	{
		TASKTRAY_NONE = 0,
		TASKTRAY_STOP = 1,
		TASKTRAY_RUN = 2,
		TASKTRAY_WARN = 3
	};

public:
	static NOTIFYICONDATA* GetTaskTrayData();

public:
	static bool IsRunning();
	static void SetRunning( bool ipRunning );

public:
	static CAppUtils::ETaskTrayIcon GetTaskTrayIcon();
	static void SetTaskTrayIcon( CAppUtils::ETaskTrayIcon ipTaskTrayIcon );

public:
	static void SetMainWndVisible( bool ipVisible, bool ipOnlyInitFlag = false );
	static bool GetMainWndVisible();

public:
	static CString GetStartupLinkPath();

public:
	static void SetDeleteServiceThread( CDeleteServiceThread* ipThread );
	static CDeleteServiceThread* GetDeleteServiceThread();

};

#endif // __APPUTILS_H__
