//	ArrestExe - File Audit Utility
//	Copyright (C) 2002-2006 AnonyMouse
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// Project Includes:
#include "stdafx.h"
#include "ArrestExe.h"
#include "ArrestExeDlg.h"

// General includes:
#include <locale.h>

// Utility includes:
#include "FileUtils.h"

// Debug Codes:
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

BEGIN_MESSAGE_MAP(CArrestExeApp, CWinApp)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

CArrestExeApp::CArrestExeApp()
{
	m_IniFilePath = NULL;
	memset( &m_NotifyIconData, 0, sizeof( m_NotifyIconData )  );
	m_IsRunning = false;
	m_TaskTrayIcon = CAppUtils::TASKTRAY_NONE;
	m_IconStop = NULL;
	m_IconRun = NULL;
	m_IconWarn = NULL;
	m_MainWndVisible = true;
	m_DeleteServiceThread = NULL;
}

CArrestExeApp theApp;

BOOL CArrestExeApp::InitInstance()
{
	// Set Language
	setlocale( LC_ALL, ARRESTEXEAPP_LOCALE );

	// Check Instance
    HANDLE lMutex = CreateMutex( FALSE, 0, _T( "__ArrestExe" ) );
    if( GetLastError() == ERROR_ALREADY_EXISTS )
    {
		return FALSE;
	}

	// Set INI Path
	CString lIniPath = CFileUtils::GetFolderPath( CFileUtils::GetModulePath() ) + m_pszProfileName;
	m_IniFilePath = new TCHAR[ lIniPath.GetLength() + 1 ];
	_tcscpy( m_IniFilePath, lIniPath );
	delete m_pszProfileName;
	m_pszProfileName = m_IniFilePath;

	// Initialize
	CoInitialize( NULL );
	InitCommonControls();
	CWinApp::InitInstance();
	AfxEnableControlContainer();

	// Load TaskTray Icon
	m_IconStop = LoadIcon( IDI_TRAY_STOP );
	m_IconRun = LoadIcon( IDI_TRAY_RUN );
	m_IconWarn = LoadIcon( IDI_TRAY_WARN );

	// Show Dialog
	CArrestExeDlg dlg;
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
	}
	else if (nResponse == IDCANCEL)
	{
	}

	// Close Mutex
	CloseHandle( lMutex );

	return FALSE;
}
