//	ArrestExe - File Audit Utility
//	Copyright (C) 2002-2006 AnonyMouse
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once

#ifndef __AUDITOPTION_H__
#define __AUDITOPTION_H__

#define AUDITOPTION_EXTENSION_SEPARATER _T( "," )

class CAuditOption
{
public:
	CAuditOption();
	~CAuditOption();

public:
	void Load();
	void Save();

public:
	CStringArray* GetAuditArray();

	CString GetExtensionList();
	void SetExtensionList( CString ipExtensionList );

	bool GetAutoRun();
	void SetAutoRun( bool ipAutoRun );

	bool GetRunAsTaskTray();
	void SetRunAsTaskTray( bool ipTaskTray );

	bool GetCompleteDelete();
	void SetCompleteDelete( bool ipCompleteDelete );

	bool GetUseScan();
	void SetUseScan( bool ipUseScan );

	bool GetUseStartSearch();
	void SetUseStartSearch( bool ipUseStartSearch );

	bool GetTrayOnStart();
	void SetTrayOnStart( bool ipTrayOnStart );

public:
	static CString GetValidExtensionList( CString ipExtensionList );

private:
	CStringArray m_AuditArray;
	CString m_ExtensionList;
	bool m_AutoRun;
	bool m_CompleteDelete;
	bool m_RunAsTaskTray;
	bool m_UseScan;
	bool m_UseStartSearch;
	bool m_TrayOnStart;
};

#endif // __AUDITOPTION_H__
