//	ArrestExe - File Audit Utility
//	Copyright (C) 2002-2006 AnonyMouse
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once

#ifndef __AUDITTHREAD_H__
#define __AUDITTHREAD_H__

#include "ThreadManager.h"

#define AUDITTHREAD_RDCW_BUFFER ( 4096 * 64 )			// RDCW Buffer ( Local )
#define AUDITTHREAD_RDCW_BUFFER_NETWORK ( 4096 * 15 )	// RDCW Buffer ( Network ) ( * 15 is Max )

#define AUDITTHREAD_FFCN_POLLING_MILLISECOND 1000		// FCCN Polling Time
#define AUDITTHREAD_SCANWAIT_POLLING_MILLISECOND 100	// SCAN Polling Time
#define AUDITTHREAD_DELETE_POLLING_MILLISECOND 300		// Delete Polling Time

#define AUDITTHREAD_FFCN_NOTIFY_FLAG ( FILE_NOTIFY_CHANGE_FILE_NAME | FILE_NOTIFY_CHANGE_DIR_NAME )
#define AUDITTHREAD_RDCW_NOTIFY_FLAG ( FILE_NOTIFY_CHANGE_FILE_NAME | FILE_NOTIFY_CHANGE_DIR_NAME )

class CAuditThread : public CThreadHandler
{
// Constructor
public:
	CAuditThread( CString ipAuditPath, CStringArray* ipExtensionArray,bool ipCompleteDelete, bool ipUseScan, bool ipUseStartSearch, int ipPollingMilliSecond, CLogWriter* ipLogWriter );
	virtual ~CAuditThread();

// Implementation
private:
	UINT RunImpl();

// Private Function
	bool ScanFolder( CString ipFilePath, bool ipAsync = false );
	bool WaitDeleteComplete();

// Override
public:
	void Cancel();

private:
	void OnEndThread();

// Private Variables
private:
	CString m_AuditPath;
	bool m_CompleteDelete;
	bool m_UseScan;
	bool m_UseStartSearch;
	CStringArray m_ExtensionArray;

private:
	bool m_InitSuccess;
	bool m_FirstRun;

private:
	HANDLE m_FFCN;

private:
	HANDLE m_DirHandle;
	HANDLE m_CompletionPort;
	ULONG m_CompletionKey;
	char* m_RDCW_Buffer;
	int m_RDCW_BufferLength;

private:
	CThreadManager* m_ScanThreadManager;
};

#endif // __AUDITTHREAD_H__
