//	ArrestExe - File Audit Utility
//	Copyright (C) 2002-2006 AnonyMouse
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// Project Includes:
#include "Stdafx.h"
#include "ArrestExe.h"
#include "CommonProcUtils.h"

// General includes:

// Utility includes:
#include "FileUtils.h"
#include "StringUtils.h"

// Debug Codes:
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

bool CCommonProcUtils::DoDeleteFile( CString ipFileName, bool ipCompleteDelete, CLogWriter* ipLogWriter )
{
	// Delete File
	bool bReturn = ipCompleteDelete ? CFileUtils::DeleteFile( ipFileName ) : CFileUtils::TrashFile( ipFileName );
	
	// Write Log
	if( bReturn )
	{
		ipLogWriter->WriteLog( CStringUtils::GetResStr( IDS_LOG_DEL_A ) + CStringUtils::GetDateStr() + CStringUtils::GetResStr( IDS_LOG_DEL_B ) + ( ipCompleteDelete ? CStringUtils::GetResStr( IDS_LOG_DEL_C_CMPDEL ) : CStringUtils::GetResStr( IDS_LOG_DEL_C_TRASH ) ) + _T( "\r\n" ) + ipFileName );
		CAppUtils::SetTaskTrayIcon( CAppUtils::TASKTRAY_WARN );
	}
	else
	{
		if( CFileUtils::IsFileExist( ipFileName ) )
		{
			ipLogWriter->WriteLog( CStringUtils::GetResStr( IDS_LOG_DEL_A ) + CStringUtils::GetDateStr() + CStringUtils::GetResStr( IDS_LOG_ERR_FAIL ) + _T( "\r\n" ) + ipFileName );
			CAppUtils::SetTaskTrayIcon( CAppUtils::TASKTRAY_WARN );
		}
	}
	
	return bReturn;
}

void CCommonProcUtils::RequestDelete( CString ipFilePath, CStringArray* ipExtensionList )
{
	// Get File Extension
	CString lExtension = CFileUtils::GetFileExt( ipFilePath );
	lExtension.MakeLower();

	// Check Extension
	bool bExtFound = false;
	for( int i = 0; i < ipExtensionList->GetCount(); i++ )
	{
		if( lExtension == ipExtensionList->GetAt( i ) )
		{
			bExtFound = true;
			break;
		}
	}
	if( !bExtFound )
	{
		return;
	}

	// Request Delete
	CAppUtils::GetDeleteServiceThread()->RequestDelete( ipFilePath );
}
