//	ArrestExe - File Audit Utility
//	Copyright (C) 2002-2006 AnonyMouse
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once

#ifndef __FILEUTILS_H__
#define __FILEUTILS_H__

#define FILE_UTILS_ANOTHER_PROCESS_USING_ERROR	32
#define FILE_UTILS_MAX_PATH 4192

class CFileUtils
{
public:
	static bool IsDirectory( CString ipFilePath );
	static bool IsFileExist( CString ipFilePath );
	static bool IsFileLocked( CString ipFilePath );
	static bool IsUsableChar( TCHAR ipChar );
	static bool IsSpecialFolder( CString ipFilePath );
	static bool IsPathEqual( CString ipPathA, CString ipPathB );
	static bool IsPathOverlap( CString ipPathA, CString ipPathB );
	static bool IsNetwork( CString ipPath );

	static bool TrashFile( CString ipFilePath );
	static bool DeleteFile( CString ipFilePath );
	static HRESULT CreateLink( CString ipSrcFilePath, CString ipLinkFilePath, CString ipDescription );

	static CString GetModulePath();
	static CString GetFolderPath( CString ipFilePath );
	static CString GetFileExt( CString ipFilePath );
	static CString GetDrive( CString ipFilePath );
	static CString GetSpecialFolderPath( int ipCSIDL, HWND ipWindowHandle = NULL );

	static CString GetSystemDirectory();
	static CString GetWindowsDirectory();
	static CString GetProgramFilesDirectory();

};

#endif // __FILEUTILS_H__
