//	ArrestExe - File Audit Utility
//	Copyright (C) 2002-2006 AnonyMouse
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// Project Includes:
#include "Stdafx.h"
#include "ArrestExe.h"
#include "FolderScanThread.h"

// General includes:

// Utility includes:
#include "FileUtils.h"
#include "StringUtils.h"
#include "CommonProcUtils.h"

// Debug Codes:
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CFolderScanThread::CFolderScanThread( CString ipScanPath, CStringArray* ipExtensionArray,bool ipCompleteDelete, int ipPollingMilliSecond, CLogWriter* ipLogWriter ):CThreadHandler( ipPollingMilliSecond, ipLogWriter )
{
	m_ScanPath = ipScanPath;
	m_CompleteDelete = ipCompleteDelete;
	for( int i = 0; i < ipExtensionArray->GetCount(); i++ )
	{
		CString lExtension = ipExtensionArray->GetAt( i );
		lExtension.MakeLower();
		m_ExtensionArray.Add( lExtension );
	}
}

CFolderScanThread::~CFolderScanThread()
{
}

UINT CFolderScanThread::RunImpl()
{
	ScanFolder( m_ScanPath );
	return CThreadHandler::THREAD_DONE;
}

bool CFolderScanThread::ScanFolder( CString ipFolderPath )
{
	bool bReturn = true;
	CString lWildCard = ipFolderPath + _T( "\\*" );
	CFileFind lFileFind;
	BOOL bFound = lFileFind.FindFile( lWildCard );
	while( bFound )
	{
		// Check Cancel
		if( IsCanceled() )
		{
			bReturn = false;
			break;
		}
		// Get Next File
		bFound = lFileFind.FindNextFile();
		if( lFileFind.IsDirectory() )
		{
			CString lFileName = lFileFind.GetFileName();
			if( lFileName != _T( "." ) && lFileName != _T( ".." ) )
			{
				// Scan Sub Directory
				if( !ScanFolder( lFileFind.GetFilePath() ) )
				{
					bReturn = false;
					break;
				}
			}
		}
		else
		{
			// Create Arrest Thread
			CCommonProcUtils::RequestDelete( lFileFind.GetFilePath(), &m_ExtensionArray );
		}
	}
	lFileFind.Close();
	return bReturn;
}

