//	ArrestExe - File Audit Utility
//	Copyright (C) 2002-2006 AnonyMouse
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// Project Includes:
#include "Stdafx.h"
#include "ArrestExe.h"
#include "TextLogWriter.h"

// General includes:

// Utility includes:
#include "StringUtils.h"

// Debug Codes:
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CTextLogWriter::CTextLogWriter( CEdit* ipEdit ):CLogWriter()
{
	m_LogEdit = ipEdit;
	m_LogEdit->SetLimitText( 0 );
	m_TextLimit = m_LogEdit->GetLimitText();
}

CTextLogWriter::~CTextLogWriter()
{
}

void CTextLogWriter::WriteLogImpl( CString ipLogText )
{
	// If Edit Control Has Limit
	if( m_TextLimit != -1 )
	{
		int lTotalLength = m_LogEdit->GetWindowTextLength() + ipLogText.GetLength();
		if( lTotalLength >= TEXTLOGWRITER_TEXTLIMIT )
		{
			m_LogEdit->SetWindowText( CStringUtils::GetResStr( IDS_LOG_TOO_LONG ) );
		}
	}

	// Add CRLF
	int lEndPosition = m_LogEdit->GetWindowTextLength();
	if( lEndPosition != 0 )
	{
		ipLogText = _T( "\r\n" ) + ipLogText;
	}

	// Add Log
	m_LogEdit->SetSel( lEndPosition, lEndPosition, FALSE );
	m_LogEdit->ReplaceSel( ipLogText );
}
