//	ArrestExe - File Audit Utility
//	Copyright (C) 2002-2006 AnonyMouse
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once

#ifndef __THREADHANDLER_H__
#define __THREADHANDLER_H__

#include "LogHandler.h"

class CThreadHandler : public CLogHandler
{
public:
	CThreadHandler( int ipPollingMilliSecond, CLogWriter* ipLogWriter );
	virtual ~CThreadHandler();

public:
	void SetHandle( HANDLE ipThreadHandle );
	HANDLE GetHandle();
	UINT Run();
	virtual void Cancel();

protected:
	bool IsCanceled();

private:
	virtual UINT RunImpl() = 0;
	virtual void OnEndThread();

protected:
	enum EThreadStatus
	{
		THREAD_DONE = 0,
		THREAD_RESUME = 1,
		THREAD_ERROR = 2
	};

private:
	HANDLE m_Thread;
	bool m_Canceled;
	int m_PollingMilliSecond;
};

#endif // __THREADHANDLER_H__
