//	ArrestExe - File Audit Utility
//	Copyright (C) 2002-2006 AnonyMouse
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once

#ifndef __THREADMANAGER_H__
#define __THREADMANAGER_H__

#include <afxmt.h>
#include "ThreadHandler.h"

class CThreadManager : public CLogHandler
{
public:
	CThreadManager( CLogWriter* ipLogWriter );
	virtual ~CThreadManager();

public:
	static UINT RunThread( LPVOID pParam );

public:
	bool Lock();
	void Unlock();

public:
	void AddThread( CThreadHandler* ipThread );	// Should Be Used After Lock
	CThreadHandler* GetThread( int ipIndex );	// Should Be Used After Lock
	void CancelAllThread();						// Should Be Used After Lock
	int GetActiveThreadCount();

private:
	static UINT WatchThread( LPVOID pParam );

private:
	typedef struct SWATCHTHREADPARAM{
		CThreadManager* m_ThreadManager;
		CThreadHandler* m_ThreadHandler;
	}SWatchThreadParam,*pWatchThreadParam;

private:
	CPtrArray m_ThreadArray;
	CCriticalSection m_CriticalSection;
	bool m_Canceled;
};

#endif // __THREADMANAGER_H__
